public class UE18Aufgabe1 {
	// Hauptprogramm
	public static void main(String[] args) {
		// ueber die Argumente werden die Spielernamen uebergeben
		if (args.length < 2) {
			IO.println("Bitte mindestens zwei Spielernamen uebergeben");
			return;
		}
		// Spieler erzeugen
		SiebenSpieler[] spieler = new SiebenSpieler[args.length];
		for (int i = 0; i < args.length-1; i++) {
			spieler[i] = new SiebenSpieler(args[i]);
		}
		spieler[args.length-1] = new SiebenProgramm(args[args.length-1]);
		// Spiel durchfuehren
		UE18Aufgabe1.spielen(spieler);
	}

	// Durchfuehrung eines kompletten Spiels mit den
	// uebergebenen Spielern
	public static void spielen(SiebenSpieler[] spieler) {
		int anzahlAusgeschieden = 0;
		int zahl = 0; // begonnen wird mit der Zahl 0
		hauptschleife: while (zahl < 10000) {
			// ab 10000 wird noch eine Runde gespielt
			// alle Spieler kommen nacheinander an die Reihe
			for (int i = 0; i < spieler.length; i++) {
				if (!spieler[i].istAusgeschieden()) {
					int ergebnis = spieler[i].naechsteZahl(zahl);
					if (!UE18Aufgabe1.check(zahl, ergebnis)) {
						spieler[i].ausscheiden();
						IO.println("Falsch! " + spieler[i]
								+ " ist ausgeschieden!");
						anzahlAusgeschieden++;
						if (anzahlAusgeschieden == spieler.length - 1) {
							// alle bis auf einen Spieler sind ausgeschieden
							break hauptschleife; // Spiel zuende
						}
					} else { // eingegebene Zahl war korrekt
						zahl = ergebnis; // zahl hochsetzen
					}
				}
			}
		}
		UE18Aufgabe1.gibSiegerBekannt(spieler);
	}

	// Bekanntgabe der/des Siegers (wer nicht ausgeschieden ist)
	public static void gibSiegerBekannt(SiebenSpieler[] spieler) {
		for (int i = 0; i < spieler.length; i++) {
			if (!spieler[i].istAusgeschieden()) {
				IO.println(spieler[i] + " ist Sieger!");
			}
		}
	}

	/**
	 * Ueberpruefung eines Spielzugs
	 * 
	 * @param aktuelleZahl
	 *            die aktuelle Zahl des Spiels
	 * @param gelieferteZahl
	 *            die vom Spieler angegebene Zahl
	 * @return genau dann true, wenn gelieferteZahl die naechst hoehere Zahl
	 *         nach aktuelleZahl ist, die keine Ziffer 7 enthaelt und nicht
	 *         durch 7 teilbar ist
	 */
	public static boolean check(int aktuelleZahl, int gelieferteZahl) {
		return UE18Aufgabe1.naechsteKorrekteZahl(aktuelleZahl) == gelieferteZahl;
	}

	private static int naechsteKorrekteZahl(int aktZahl) {
		aktZahl++;
		if (aktZahl % 7 == 0 || UE18Aufgabe1.enthaelt7(aktZahl)) {
			return UE18Aufgabe1.naechsteKorrekteZahl(aktZahl);
		} else {
			return aktZahl;
		}
	}

	private static boolean enthaelt7(int zahl) {
		zahl = Math.abs(zahl);
		while (zahl > 9) {
			if (zahl % 10 == 7) {
				return true;
			}
			zahl /= 10;
		}
		return zahl == 7;
	}
}

class SiebenSpieler {
	private String name;

	private boolean ausgeschieden;

	public SiebenSpieler(String name) {
		this.name = name;
		this.ausgeschieden = false;
	}

	@Override
	public String toString() {
		return this.name;
	}

	public int naechsteZahl(int vorherigeZahl) {
		return IO.readInt(this + ": Zahl nach " + vorherigeZahl + ": ");
	}

	public void ausscheiden() {
		this.ausgeschieden = true;
	}

	public boolean istAusgeschieden() {
		return this.ausgeschieden;
	}
}

class SiebenProgramm extends SiebenSpieler {

	public SiebenProgramm(String name) {
		super(name);
	}

	@Override
	public int naechsteZahl(int vorherigeZahl) {
		int meineZahl = vorherigeZahl + 1;
		while (meineZahl != SiebenProgramm.naechsteKorrekteZahl(vorherigeZahl)) {
			meineZahl++;
		}
		return meineZahl;
	}

	private static int naechsteKorrekteZahl(int aktZahl) {
		aktZahl++;
		if (aktZahl % 7 == 0 || SiebenProgramm.enthaelt7(aktZahl)) {
			return SiebenProgramm.naechsteKorrekteZahl(aktZahl);
		} else {
			return aktZahl;
		}
	}

	private static boolean enthaelt7(int zahl) {
		zahl = Math.abs(zahl);
		while (zahl > 9) {
			if (zahl % 10 == 7) {
				return true;
			}
			zahl /= 10;
		}
		return zahl == 7;
	}

}
