public class UE18Aufgabe14 {

	public static void main(String[] args) {
		final int n = 3;
		Player player1 = new Mensch();
		Player player2 = new DummyKI();
		NimSpiel spiel = new NimSpiel(player1, player2, n);
		spiel.spielen();
	}

}

interface Player {
	// haufen darf nicht verndert werden
	public Turn nextTurn(int[] haufen);
}

class Mensch implements Player {
	public Turn nextTurn(int[] haufen) {
		int haufenIndex = IO.readInt("Index des Haufens: ");
		int anzahl = IO.readInt("Kugeln: ");
		return new Turn(haufenIndex, anzahl);
	}
}

class DummyKI implements Player {
	public Turn nextTurn(int[] haufen) {
		for (int i=0; i<haufen.length; i++) {
			if (haufen[i] > 0) {
				return new Turn(i, haufen[i]);
			}
		}
		return null;
	}
}

class NimSpiel {

	Player player1;
	Player player2;
	int[] haufen;

	NimSpiel(Player player1, Player player2, int n) {
		this.player1 = player1;
		this.player2 = player2;
		this.haufen = new int[n];
		for (int i = 0; i < n; i++) {
			this.haufen[i] = n;
		}
	}

	void spielen() {
		print();

		Player currentPlayer = player1;
		while (!end()) {
			if (currentPlayer == player1) {
				System.out.println("Spieler 1 ist an der Reihe");
			} else {
				System.out.println("Spieler 2 ist an der Reihe");
			}
			Turn turn = currentPlayer.nextTurn(haufen);
			if (!check(turn)) {
				System.out.println("Falscher Zug! Spieler hat verloren");
				return;
			}
			perform(turn);
			print();
			if (!end()) {
				currentPlayer = spielerwechsel(currentPlayer);
			}
		}
		if (currentPlayer == player1) {
			System.out.println("Sieger ist Spieler 1");
		} else {
			System.out.println("Sieger ist Spieler 2");
		}
	}

	void print() {
		for (int i = 0; i < haufen.length; i++) {
			System.out.println(haufen[i]);
		}
		System.out.println();
	}

	Player spielerwechsel(Player current) {
		if (current == player1) {
			return player2;
		} else {
			return player1;
		}
	}

	boolean check(Turn turn) {
		if (turn.getHaufenIndex() < 0 || turn.getHaufenIndex() >= haufen.length) {
			return false;
		}
		if (turn.getKugeln() > haufen[turn.getHaufenIndex()]) {
			return false;
		}
		if (turn.getKugeln() <= 0) {
			return false;
		}
		return true;
	}

	void perform(Turn turn) {
		this.haufen[turn.getHaufenIndex()] -= turn.getKugeln();
	}

	boolean end() {
		for (int i = 0; i < haufen.length; i++) {
			if (haufen[i] > 0) {
				return false;
			}
		}
		return true;
	}
}

class Turn {
	int haufenIndex;
	int kugeln;

	Turn(int index, int anzahl) {
		this.haufenIndex = index;
		this.kugeln = anzahl;
	}

	public int getHaufenIndex() {
		return haufenIndex;
	}

	public int getKugeln() {
		return kugeln;
	}
}
