import java.util.ArrayList;

public class UE18Aufgabe15 {

	public static void main(String[] args) {
		// leeres Sparschwein erzeugen
		Sparschwein schwein = new Sparschwein();
		
		// beliebige Muenzen ins Sparschwein einwerfen
		schwein.einwerfen(new ZweiCentMuenze());
		schwein.einwerfen(new EinCentMuenze());
		schwein.einwerfen(new ZweiCentMuenze());
		schwein.einwerfen(new EinEuroMuenze());
		schwein.einwerfen(new ZweiCentMuenze());
		// ...
		
		// aktuellen Wert des Sparschweins ermitteln (in Cent)
		int wert = schwein.liefereWertInCent();
		System.out.println("Im Schwein befinden sich " + (wert / 100.0) + " Euro");
		
		// alle Muenzen eines bestimmten Typs aus dem Sparschwein entfernen;
		// hier alle Zwei-Cent-Muenzen
		schwein.entfernen(ZweiCentMuenze.class);
		
		// alle Muenzen aus dem Sparschwein entfernen und ihren Wert (in Cent) liefern
		wert = schwein.leeren();
		System.out.println("Im Schwein befanden sich " + (wert / 100.0) + " Euro");
	}

}

class Muenze {
	protected int wertInCent;

	public Muenze(int wert) {
		this.wertInCent = wert;
	}

	public int getWertInCent() {
		return this.wertInCent;
	}
}

class EinCentMuenze extends Muenze {
	public EinCentMuenze() {
		super(1);
	}
}

class ZweiCentMuenze extends Muenze {
	public ZweiCentMuenze() {
		super(2);
	}
}

class EinEuroMuenze extends Muenze {
	public EinEuroMuenze() {
		super(100);
	}
}

class Sparschwein {
	private ArrayList<Muenze> muenzen;

	public Sparschwein() {
		this.muenzen = new ArrayList<Muenze>();
	}

	public void einwerfen(Muenze muenze) {
		this.muenzen.add(muenze);
	}
	
	public void entfernen(Class muenzKlasse) {
		int i = 0;
		while (i < muenzen.size()) {
			if (muenzen.get(i).getClass() == muenzKlasse) {
				muenzen.remove(i);
			} else {
				i++;
			}
		}
	}
	
	public int liefereWertInCent() {
		int cents = 0;
		for (Muenze muenze : muenzen) {
			cents += muenze.getWertInCent();
		}
		return cents;
	}

	public int leeren() {
		int wert = liefereWertInCent();
		muenzen.clear();
		return wert;
	}
}
